using System;
using bizFacade;
//using SystemFramework;
using MesServerWork;

namespace MesServerFunctions
{
    partial class FunctionMES
    {
        object lockMesRead = new object ();
        /// <summary>
        /// 保存完成(针对半自动和手动压装工位)
        /// </summary>
        /// <param name="OpName"></param>
        /// <param name="tagValue"></param>
        private void MesRead(object e)
        {
            lock(lockMesRead)
            {
                try
                {
                    int EngineTypeID;
                    string EngineType;
                    string EngineID;
                    int PartPallet_Code;
                    string OrderForm;

                    {
                        DoWhatPlc.CustomeEvetnArgs msgEvent = (DoWhatPlc.CustomeEvetnArgs)e;
                        string OpName = Convert.ToString(msgEvent.OpName);
                        int tagValue = Convert.ToInt32(msgEvent.TagValue);

                        if (tagValue == 1)
                        {
                            MIS_BASE.GetEngineTypeFromPLC(OpName, out EngineTypeID, out EngineType, out EngineID, out PartPallet_Code, out OrderForm);
                            //保存数据到线首表 先保存到  北汽福田变速器序列号总线上线  用于之前判断是否重号
                            if (Db.UpLoadOpNameInsert(EngineID, EngineTypeID, EngineType, OpName))
                            {
                                //保存质量数据
                                int qualityMask = MisDataSaveDateMesRead.Funtion.MesRead(OpName, tagValue.ToString(), msgEvent.TagID.ToString());
                                //推送质量数据到MES的页面
                                MIS_BASE.SendInfomation("ShowTimelyQuality", "1&" + qualityMask.ToString(), OpName);

                                BaseDataSystemMES.OpName_MIS_MOBY_Insert(OpName, MobyTagType.WorkStartOut, DateTime.Now.ToString());

                                //保存物料数据
                                BaseDataSystemMES.Material_Insert(OpName, tagValue);
                                //测量数据发动机在线状态
                                BaseDataSystemMES.WorkStartInsert(OpName, qualityMask);

                                // MIS_BASE.Write_ConfirmOkGo(OpName, true);

                                //MisDataSaveDate.
                                MIS_BASE.Write_MesReadOver(OpName, true);
                                MIS_BASE.Write_MaterialVerifyOver(OpName, true);
                                SendMessage.SendActuallyCount(OpName, tagValue);//统计在线产量，在线节拍
                            }
                            else
                            {
                                SendMessage.AsyncSendMessage_Notice(OpName, "保存上线数据失败！");
                            }
                        }
                        else
                        {
                            MIS_BASE.Write_MesReadOver(OpName, false);
                            MIS_BASE.Write_MaterialVerifyOver(OpName, false);
                            MIS_BASE.Write_ConfirmOkGo(OpName, false);
                            MIS_BASE.Write_FixAllow(OpName, false);
                            MIS_BASE.Write_ConfirmOkGo(OpName, false);
                            MIS_BASE.Write_ConfirmOkGo(OpName, false);
                        }

                    }

                }
                catch (Exception err)
                {
                    ////ApplicationLog.WriteLog(err, "Function08:MesReadOver");
                }

            }
           
        }
    }
}
